------------------------------------------------------------------------------
--                                 Ada2Java                                 --
--                                                                          --
--                     Copyright (C) 2007-2013, AdaCore                     --
--                                                                          --
-- This is free software;  you can redistribute it  and/or modify it  under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 3,  or (at your option) any later ver- --
-- sion.  This software is distributed in the hope  that it will be useful, --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License for  more details.  You should have  received  a copy of the GNU --
-- General  Public  License  distributed  with  this  software;   see  file --
-- COPYING3.  If not, go to http://www.gnu.org/licenses for a complete copy --
-- of the license.                                                          --
------------------------------------------------------------------------------

package Ada2Java.Bound_Elements.References is

   type Bound_Reference is new Bound_Element_Record with private;
   --  Bound references are used to represent references to references, for
   --  example an out access parameter.

   procedure Initialize
     (Handle        : not null access Kernel.Kernel_Record;
      Element       : Simple_Element_View_Access;
      Element_Bound : access Bound_Reference);

   overriding
   procedure Bind
     (Element_Bound : access Bound_Reference;
      Handle        : not null access Kernel.Kernel_Record);

   function Get_JNI_Constructor
     (Element : Bound_Reference) return Dynamic_Expression;

private

   type Bound_Reference is new Bound_Element_Record with record
      JNI_Constructor : Dynamic_Expression;
   end record;

end Ada2Java.Bound_Elements.References;
